@echo off
TITLE Setup NGINX and PHP on this computer.
ECHO.

REM --> CHANGE PHP PORTS HERE IF YOU HAVE OTHER SERVICES RUNNING ON PORTS 9000,9001,9002 or 9003
SET PHP_PORT1=9000
SET PHP_PORT2=9001
SET PHP_PORT3=9002
SET PHP_PORT4=9003

SET CWD=%CD:~0,3%
if not exist "%systemdrive%\Program Files (x86)" (
    ECHO 32-bit OS DETECTED! This is only for 64-bits!
	GOTO END
)

:: BatchGotAdmin
:-------------------------------------
REM  --> Check for permissions
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"

REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges... Choose to allow.
    goto UACPrompt
) else ( goto gotAdmin )

:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params = %*:"="
    echo UAC.ShellExecute "cmd.exe", "/c %~s0 %params%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    del "%temp%\getadmin.vbs"
    exit /B

:gotAdmin
    pushd "%CD%"
    CD /D "%~dp0"
:--------------------------------------

echo This utility will set up the basics for a local webserver on this computer.
echo If you already setup a server using this utility, then any changes will completely overwrite previous!

:LOOP
SET Choice=
SET /P Choice="Do you want to proceed with setting up the server? (Y/N)"

IF NOT '%Choice%'=='' SET Choice=%Choice:~0,1%

ECHO.
IF /I '%Choice%'=='Y' GOTO SETUPSERVER
IF /I '%Choice%'=='y' GOTO SETUPSERVER
IF /I '%Choice%'=='N' GOTO DONOTSETUP
IF /I '%Choice%'=='n' GOTO DONOTSETUP
ECHO Please type Y or N to proceed!
ECHO.
GOTO Loop


:DONOTSETUP
ECHO Nothing was changed. Good-bye!
GOTO END


:SETUPSERVER
SET NEWLINE=^& echo.

SET DOMAIN_NAME=
ECHO What is the domain name you wish to setup?

SET /p DOMAIN_NAME=""
ECHO Domain: %DOMAIN_NAME%

SET DOMAIN_PORT=80
ECHO.
ECHO What Port do you wish to listen on for this domain? 
ECHO 	(Default is 80. If you have another webserver running on this PC, you could use something like 8080.)
SET /p DOMAIN_PORT=""
ECHO Domain Port: %DOMAIN_PORT%


set "TAB=	"
(
ECHO upstream php_farm {
ECHO %TAB%server 127.0.0.1:%PHP_PORT1% weight=1;
ECHO %TAB%server 127.0.0.1:%PHP_PORT2% weight=1;
ECHO %TAB%server 127.0.0.1:%PHP_PORT3% weight=1;
ECHO %TAB%server 127.0.0.1:%PHP_PORT4% weight=1;
ECHO }
ECHO.
ECHO server {
ECHO %TAB%listen	%DOMAIN_PORT%;
ECHO %TAB%# REMOVE THE "#" ON THE NEXT 4 LINES TO ENABLE SSL AFTER YOU GENERATE THE KEYS. MAKE SURE domain.crt AND domain.key FILES EXISTS!
ECHO %TAB%# listen 443 ssl;
ECHO %TAB%# ssl on;
ECHO %TAB%# ssl_certificate %CWD%webserver\certs\domain.crt;
ECHO %TAB%# ssl_certificate_key %CWD%webserver\certs\domain.key;
ECHO.
ECHO %TAB%server_name	%DOMAIN_NAME%;
ECHO %TAB%root   %CWD%webserver\public_html;
ECHO.
ECHO %TAB%location / {
ECHO %TAB%%TAB%index  index.php index.html index.htm;
ECHO %TAB%}
ECHO.
ECHO %TAB%error_page   500 502 503 504  /50x.html;
ECHO.	
ECHO %TAB%location = /50x.html {
ECHO %TAB%%TAB%root   html;
ECHO %TAB%}
ECHO.
ECHO %TAB%error_page   404  /40x.html;
ECHO.
ECHO %TAB%location = /40x.html {
ECHO %TAB%%TAB%root   html;
ECHO %TAB%}
ECHO.
ECHO %TAB%location ~ \.php$ {
ECHO %TAB%%TAB%root   %CWD%webserver\public_html;
ECHO %TAB%%TAB%fastcgi_pass   php_farm;
ECHO %TAB%%TAB%fastcgi_index  index.php;
ECHO %TAB%%TAB%fastcgi_param  SCRIPT_FILENAME  $document_root$fastcgi_script_name;
ECHO %TAB%%TAB%include        fastcgi_params;
ECHO %TAB%%TAB%client_max_body_size 100M;
ECHO %TAB%}
ECHO.
ECHO %TAB%location ~* \.^(js^|css^|woff^|woff2^|eot^|ttf^|jpg^|png^)$ {
ECHO %TAB%%TAB%expires 60d;
ECHO %TAB%}
ECHO.
ECHO %TAB%gzip on;
ECHO %TAB%gzip_http_version  1.1;
ECHO %TAB%gzip_comp_level    5;
ECHO %TAB%gzip_min_length    256;
ECHO %TAB%gzip_vary          on;
ECHO %TAB%gzip_types
ECHO %TAB%application/javascript
ECHO %TAB%application/json
ECHO %TAB%application/rss+xml
ECHO %TAB%application/x-font-ttf
ECHO %TAB%application/x-web-app-manifest+json
ECHO %TAB%application/xhtml+xml
ECHO %TAB%application/xml
ECHO %TAB%font/opentype
ECHO %TAB%image/svg+xml
ECHO %TAB%image/x-icon
ECHO %TAB%text/css
ECHO %TAB%text/plain;
ECHO.
ECHO })>nginx/conf/nginx_custom.conf

ECHO.
ECHO UPDATED /webserver/nginx/conf/nginx_custom.conf



(
ECHO @ECHO OFF
ECHO ECHO. Starting NGINX and PHP...
ECHO PING -n 2 127.0.0.1^>nul
ECHO SET PHP_FCGI_MAX_REQUESTS=0
ECHO start ^/d "%CWD%webserver\nginx" nginx.exe
ECHO %CWD%webserver^\utilities^\RunHiddenConsole.exe %CWD%webserver^\php^\php-cgi.exe -b 127.0.0.1:%PHP_PORT1%
ECHO %CWD%webserver^\utilities^\RunHiddenConsole.exe %CWD%webserver^\php^\php-cgi.exe -b 127.0.0.1:%PHP_PORT2%
ECHO %CWD%webserver^\utilities^\RunHiddenConsole.exe %CWD%webserver^\php^\php-cgi.exe -b 127.0.0.1:%PHP_PORT3%
ECHO %CWD%webserver^\utilities^\RunHiddenConsole.exe %CWD%webserver^\php^\php-cgi.exe -b 127.0.0.1:%PHP_PORT4%)>start-nginx-php.cmd

ECHO.
ECHO CREATED %CD:~0,3%webserver\start-nginx-php.cmd
ECHO. Use this to start NGINX and PHP.
ECHO.
:TASK_CREATE1
SET CHOOSE_TASK_CREATE1=
ECHO.
SET /P CHOOSE_TASK_CREATE1="Automatically start NGINX & PHP when the PC starts? (Y/N)"
IF NOT '%CHOOSE_TASK_CREATE1%'=='' SET CHOOSE_TASK_CREATE1=%CHOOSE_TASK_CREATE1:~0,1%
ECHO.
IF /I '%CHOOSE_TASK_CREATE1%'=='Y' GOTO DO_CREATE_TASK1
IF /I '%CHOOSE_TASK_CREATE1%'=='y' GOTO DO_CREATE_TASK1
IF /I '%CHOOSE_TASK_CREATE1%'=='N' GOTO CREATE_STOP_START
IF /I '%CHOOSE_TASK_CREATE1%'=='n' GOTO CREATE_STOP_START
ECHO Please type Y or N to proceed!
ECHO.
GOTO TASK_CREATE1

:DO_CREATE_TASK1
schtasks.exe /ru SYSTEM /Create /SC ONSTART /TN "START NGINX & PHP" /TR "%CWD%webserver\start-nginx-php.cmd"
ECHO You can modify or delete the task ("START NGING & PHP")later in Control Panel ^> Administrative Tools ^> Task Scheduler.
ECHO After installing DistriFile, you can open %CWD%webserver\create-scheduled-task-cron.cmd to create a task that automatically processes backend functions of DistriFile on a regular interval. Similar to Linux crontab.
ECHO.
GOTO CREATE_STOP_START

:CREATE_STOP_START
(
ECHO @ECHO off
ECHO :: BatchGotAdmin
ECHO :-------------------------------------
ECHO :: --^> Check for permissions
ECHO ^>nul 2^>^&1 "%%SYSTEMROOT%%\system32\cacls.exe" "%%SYSTEMROOT%%\system32\config\system"
ECHO.
ECHO :: --^> If error flag set, we do not have admin.
ECHO if '%%errorlevel%%' NEQ '0' (
ECHO %TAB%echo Requesting administrative privileges... Choose to allow.
ECHO %TAB%goto UACPrompt
ECHO ^) else ^( goto gotAdmin ^)
ECHO.
ECHO :UACPrompt
ECHO %TAB%echo Set UAC = CreateObject^("Shell.Application"^) ^> "%%temp%%\getadmin.vbs"
ECHO %TAB%set params = %%*:^"=^"
ECHO %TAB%echo UAC.ShellExecute "cmd.exe", "/c %%~s0 %%params%%", "", "runas", 1 ^>^> "%%temp%%\getadmin.vbs"
ECHO.
ECHO %TAB%"%%temp%%\getadmin.vbs"
ECHO %TAB%del "%%temp%%\getadmin.vbs"
ECHO %TAB%exit /B
ECHO.
ECHO :gotAdmin
ECHO taskkill ^/f ^/IM nginx.exe
ECHO taskkill ^/f ^/IM php-cgi.exe
ECHO ECHO. Starting NGINX and PHP...
ECHO PING -n 3 127.0.0.1^>nul
ECHO SET PHP_FCGI_MAX_REQUESTS=0
ECHO start ^/d "%CWD%webserver\nginx" nginx.exe
ECHO %CWD%webserver^\utilities^\RunHiddenConsole.exe %CWD%webserver^\php^\php-cgi.exe -b 127.0.0.1:%PHP_PORT1%
ECHO %CWD%webserver^\utilities^\RunHiddenConsole.exe %CWD%webserver^\php^\php-cgi.exe -b 127.0.0.1:%PHP_PORT2%
ECHO %CWD%webserver^\utilities^\RunHiddenConsole.exe %CWD%webserver^\php^\php-cgi.exe -b 127.0.0.1:%PHP_PORT3%
ECHO %CWD%webserver^\utilities^\RunHiddenConsole.exe %CWD%webserver^\php^\php-cgi.exe -b 127.0.0.1:%PHP_PORT4%)>stop-start-nginx-php.cmd

ECHO.
ECHO CREATED %CD:~0,3%webserver\stop-start-nginx-php.cmd
ECHO. Use this to RESTART NGINX and PHP at any time you need such as after updating any config files.
ECHO.

(
ECHO @ECHO off
ECHO :: BatchGotAdmin
ECHO :-------------------------------------
ECHO :: --^> Check for permissions
ECHO ^>nul 2^>^&1 "%%SYSTEMROOT%%\system32\cacls.exe" "%%SYSTEMROOT%%\system32\config\system"
ECHO.
ECHO :: --^> If error flag set, we do not have admin.
ECHO if '%%errorlevel%%' NEQ '0' (
ECHO %TAB%echo Requesting administrative privileges... Choose to allow.
ECHO %TAB%goto UACPrompt
ECHO ^) else ^( goto gotAdmin ^)
ECHO.
ECHO :UACPrompt
ECHO %TAB%echo Set UAC = CreateObject^("Shell.Application"^) ^> "%%temp%%\getadmin.vbs"
ECHO %TAB%set params = %%*:^"=^"
ECHO %TAB%echo UAC.ShellExecute "cmd.exe", "/c %%~s0 %%params%%", "", "runas", 1 ^>^> "%%temp%%\getadmin.vbs"
ECHO.
ECHO %TAB%"%%temp%%\getadmin.vbs"
ECHO %TAB%del "%%temp%%\getadmin.vbs"
ECHO %TAB%exit /B
ECHO.
ECHO :gotAdmin
ECHO taskkill ^/f ^/IM nginx.exe
ECHO taskkill ^/f ^/IM php-cgi.exe
ECHO ECHO. Stopping NGINX and PHP.
ECHO PING -n 2 127.0.0.1^>nul)>stop-nginx-php.cmd

ECHO.
ECHO CREATED %CD:~0,3%webserver\stop-nginx-php.cmd
ECHO. Use this to completely STOP NGINX and PHP.
ECHO.

:LOOP_HOSTS
SET CHOOSE_HOSTS=
SET /P CHOOSE_HOSTS="Update HOSTS file so that %DOMAIN_NAME% always points to this PC? (Y/N)"

IF NOT '%CHOOSE_HOSTS%'=='' SET CHOOSE_HOSTS=%CHOOSE_HOSTS:~0,1%

ECHO.
IF /I '%CHOOSE_HOSTS%'=='Y' GOTO ACCEPTED
IF /I '%CHOOSE_HOSTS%'=='y' GOTO ACCEPTED
IF /I '%CHOOSE_HOSTS%'=='N' GOTO REJECTED
IF /I '%CHOOSE_HOSTS%'=='n' GOTO REJECTED
ECHO Please type Y or N to proceed!
ECHO.
GOTO LOOP_HOSTS


:REJECTED
ECHO Your HOSTS file was left unchanged.
GOTO LOOP_DOWNLOAD


:ACCEPTED

SET NEWLINE=^& ECHO.
ECHO Updating your HOSTS file...
FIND /C /I "%DOMAIN_NAME%" %WINDIR%\system32\drivers\etc\hosts
IF %ERRORLEVEL% NEQ 0 ECHO %NEWLINE%>>%WINDIR%\system32\drivers\etc\hosts
IF %ERRORLEVEL% NEQ 0 ECHO 127.0.0.1 %DOMAIN_NAME%>>%WINDIR%\system32\drivers\etc\hosts
ipconfig /flushdns
ECHO %DOMAIN_NAME% will now be run like localhost.

:LOOP_DOWNLOAD
SET CHOOSE_DOWNLOAD=
ECHO.
SET /P CHOOSE_DOWNLOAD="Download the DistriFile Easy Installer? (Y/N)"

IF NOT '%CHOOSE_DOWNLOAD%'=='' SET CHOOSE_DOWNLOAD=%CHOOSE_DOWNLOAD:~0,1%

ECHO.
IF /I '%CHOOSE_DOWNLOAD%'=='Y' GOTO DOWNLOAD_INSTALLER
IF /I '%CHOOSE_DOWNLOAD%'=='y' GOTO DOWNLOAD_INSTALLER
IF /I '%CHOOSE_DOWNLOAD%'=='N' GOTO SKIP_DOWNLOAD
IF /I '%CHOOSE_DOWNLOAD%'=='n' GOTO SKIP_DOWNLOAD
ECHO Please type Y or N to proceed!
ECHO.
GOTO LOOP_DOWNLOAD

:SKIP_DOWNLOAD
ECHO Skipped download.
GOTO OPEN_SERVER

:DOWNLOAD_INSTALLER
%WINDIR%\system32\WindowsPowerShell\v1.0\powershell.exe -ExecutionPolicy Bypass -File "%CWD%webserver\utilities\download-extract-distrifile-easy.ps1"
GOTO OPEN_SERVER


:OPEN_SERVER
ECHO Starting NGINX and PHP...
PING -n 2 127.0.0.1>nul
SET PHP_FCGI_MAX_REQUESTS=0
start /d "%CWD%webserver\nginx" nginx.exe
%CWD%webserver\utilities\RunHiddenConsole.exe %CWD%webserver\php\php-cgi.exe -b 127.0.0.1:%PHP_PORT1%
%CWD%webserver\utilities\RunHiddenConsole.exe %CWD%webserver\php\php-cgi.exe -b 127.0.0.1:%PHP_PORT2%
%CWD%webserver\utilities\RunHiddenConsole.exe %CWD%webserver\php\php-cgi.exe -b 127.0.0.1:%PHP_PORT3%
%CWD%webserver\utilities\RunHiddenConsole.exe %CWD%webserver\php\php-cgi.exe -b 127.0.0.1:%PHP_PORT4%
PING -n 4 127.0.0.1>nul
start http://%DOMAIN_NAME%

GOTO END

:END
ECHO.
TIMEOUT 3 /nobreak
EXIT